unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ACMConvertor, StdCtrls,mmsystem,AudioInfo, ALCommonGen,
  ALGenericGen, TeEngine, Series, ExtCtrls, TeeProcs, Chart,WaveFileWrite,
  XPMan, ComCtrls;

type
   TMpegLayer3WaveFormat = packed record
      wfx: TWaveFormatEx;
      wID: WORD;
      fdwFlags: DWORD;
      nBlockSize: WORD;
      nFramesPerBlock: WORD;
      nCodecDelay: WORD;
   end;

  TForm1 = class(TForm)
    Button1: TButton;
    ProgressBar1: TProgressBar;
    XPManifest1: TXPManifest;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    WaveFile_Write:TWaveFile_Write;
    acm1:TACMWaveFormat;
    acm2:TACMWaveFormat;
    OutPoint:^smallint;
    A:TAudioInfo;
    Str:TStringStream;
    FileStream : TFileStream;
    Size:Integer;

    Index:Integer;
    { Public declarations }
  end;

var
  Form1: TForm1;
  ACMConvertor1 : TACMConvertor;
  AudioInfo:TAudioInfo;
  FileStr:TextFile;
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  acm1_H:TACMWaveFormat;
  acm1_MPEG:TMpegLayer3WaveFormat absolute acm1_H;
  acm2_MPEG:TMpegLayer3WaveFormat;

begin
  if Not OpenDialog1.Execute  then
    Halt;
  Application.ProcessMessages;
  if not SaveDialog1.Execute then
    Halt;
  AudioInfo := TAudioInfo.Create;

  AudioInfo.LoadFromFile(OpenDialog1.FileName);
  //caption := inttostr(AudioInfo.MpegPosition);
  ACMConvertor1 := TACMConvertor.Create(Self);
  FileStream := TFileStream.Create(OpenDialog1.FileName,fmOpenRead);
  assignfile(FileStr,'C:\MP3.txt');
  Rewrite(FileStr);
  Writeln(FileStr,'Usual:');
  Writeln(FileStr,'FileSize:'+inttostr(AudioInfo.FileSize));
  Writeln(FileStr,'Mpeg Duration:'+inttostr(AudioInfo.MpegDuration));
  Writeln(FileStr,'Max Gap Before Mpeg:'+inttostr(AudioInfo.MaxGapBeforeMpeg));
  Writeln(FileStr,'Mpeg Position:'+inttostr(AudioInfo.MpegPosition));
  Writeln(FileStr,'MP3 Header Info:');
  Writeln(FileStr,'Version:'+inttostr(AudioInfo.Mpg.Version));
  Writeln(FileStr,'Layer:'+inttostr(AudioInfo.Mpg.Layer));
  Writeln(FileStr,'KBitRate:'+inttostr(AudioInfo.Mpg.KBitRate));
  Writeln(FileStr,'BitRate:'+inttostr(AudioInfo.Mpg.BitRate));
  Writeln(FileStr,'SamplingRate:'+inttostr(AudioInfo.Mpg.SamplingRate));
  Writeln(FileStr,'PaddingLen:'+inttostr(AudioInfo.Mpg.PaddingLen));
  Writeln(FileStr,'ChannelMode:'+inttostr(AudioInfo.Mpg.ChannelMode));
  Writeln(FileStr,'Emphasis:'+inttostr(AudioInfo.Mpg.Emphasis));
  Writeln(FileStr,'FrameLen:'+inttostr(AudioInfo.Mpg.FrameLen));
  Writeln(FileStr,'Track:'+inttostr(AudioInfo.ID3.Track));
  Writeln(FileStr,'GenreID:'+inttostr(AudioInfo.ID3.GenreID));
  Writeln(FileStr,'FrameLen:'+inttostr(AudioInfo.Mpg.FrameLen));

  FileStream.Seek(AudioInfo.MpegPosition,soFromBeginning);
  zeromemory(@acm1,sizeof(acm1));
  zeromemory(@acm2,sizeof(acm2));
  zeromemory(@acm1_MPEG,sizeof(acm1_MPEG));
  //ACMConvertor1.ChooseFormat(acm1,True);
  acm1_H := acm1;
  acm1_MPEG.wfx.wFormatTag := 85;
  case AudioInfo.Mpg.ChannelMode of
    0:
    begin
      acm1_MPEG.wfx.nChannels := 2;
      acm1_MPEG.fdwFlags := 2;
    end;
    1:
    begin
      acm1_MPEG.wfx.nChannels := 2;
      acm1_MPEG.fdwFlags := 4;
    end;
    2:
    begin
      acm1_MPEG.wfx.nChannels := 2;
      acm1_MPEG.fdwFlags := 2;
    end;
    3:
    begin
      acm1_MPEG.wfx.nChannels := 1;
      acm1_MPEG.fdwFlags := 4;
    end;
  end;

  acm1_MPEG.wfx.nSamplesPerSec := AudioInfo.Mpg.SamplingRate;
  acm1_MPEG.wfx.nAvgBytesPerSec := AudioInfo.Mpg.BitRate div 8;
  acm1_MPEG.wfx.nBlockAlign := 1;
  acm1_MPEG.wfx.wBitsPerSample := 0;
  acm1_MPEG.wfx.cbSize := 12;
  acm1_MPEG.wID := 1;
  acm1_MPEG.nBlockSize := AudioInfo.Mpg.FrameLen;

  acm1_MPEG.nFramesPerBlock := 1;
  acm1_MPEG.nCodecDelay := 0;
  copymemory(@acm1,@acm1_H,Sizeof(TMpegLayer3WaveFormat));

  acm2 := ACMConvertor1.SuggestFormat(acm1);
  //ACMConvertor1.Active := True;
  ACMConvertor1.FormatIn := acm1;
  ACMConvertor1.FormatOut := acm2;
  ACMConvertor1.OpenStream;
  zeromemory(ACMConvertor1.BufferIn,ACMConvertor1.InputBufferSize);


  WaveFile_Write := TWaveFile_Write.Create(Self);
  WaveFile_Write.AssignFileName(SaveDialog1.FileName);
  WaveFile_Write.FMTchunk.WaveFMT.WaveFormat := acm2.Format;
  WaveFile_Write.Initialize;
  Index := 0;
  Timer1.Enabled := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  acm1_H:TACMWaveFormat;
  acm1_MPEG:TMpegLayer3WaveFormat absolute acm1_H;
  Counter:Integer;
  Found:Boolean;
  Adder:Integer;
  BytPointer:^Byte;
  Readed : Int64;
begin
  Readed := AudioInfo.MpegPosition;
  while Readed < FileStream.Size do
  begin
  if (FileStream.Size-AudioInfo.MpegPosition) <> 0 then
    ProgressBar1.Position := ( (Readed - AudioInfo.MpegPosition) * ProgressBar1.Max Div (FileStream.Size-AudioInfo.MpegPosition));
  acm1_H := acm1;

  Size := ACMConvertor1.InputBufferSize;
  //FileStream.Seek((acm1_MPEG.wfx.cbSize-2) * acm1_MPEG.nBlockSize*Index,soFromBeginning);
  Index := Index + 1;
  FileStream.Read(ACMConvertor1.BufferIn^,Size);
  ACMConvertor1.Convert;




  WaveFile_Write.AddData(ACMConvertor1.BufferOut^,ACMConvertor1.FStreamHeader_P.cbDstLengthUsed);
  Writeln(FileStr,inttostr(ACMConvertor1.FStreamHeader_P.cbDstLengthUsed));
  Readed  := Readed + Size;
  Application.ProcessMessages;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Button1.Click;

  Showmessage('Converted');
  closefile(FileStr);
  close;
end;

end.
